open World
open Robots


type sta = Strategie.stratacc

class dummy_strat : Strategie.stratacc = object
  method nextmove world =
    (new dummy_strat, Some (World.Move World.N, 1))
end


class dumb_goto_strat x y me = object
  val mypath : (int * int) list option = None

  method nextmove world =
    let me = get_robot world me in
    let thepath = match mypath with Some x -> x
    | None -> List.rev (snd (Hashtbl.find (Strategie.paths world me.rposition) (x, y)))
    in
    match thepath with
      [] -> {< mypath = Some [] >}, (Pick [], 1)
    | xy::xs -> {< mypath = Some xs >}, (Move (get_move me.rposition xy), 1)
end

class stratnull : Strategie.stratacc = object (self)
  method nextmove w = (self :> Strategie.stratacc), None
end

class goto_strat_helper world pos me strat_to_apply =
  let my_pos = (get_robot world me).rposition in
  let path_computer = Strategie.get_path_computer world my_pos in
  let path = 
    try
      Some (my_pos :: Strategie.get_path path_computer pos)
    with Not_found -> 
      None in
object(self)
  val pos = pos
  val path = path
  val me = me
  val world = world
		
  method my_pos = (get_robot world me).rposition
		    
  method nextmove world =
    let new_goto () =
      (new goto_strat_helper world pos me strat_to_apply :>
       Strategie.stratacc)#nextmove world in
    if self#my_pos = pos then
      (strat_to_apply  :> Strategie.stratacc)#nextmove world
    else
      match path with
      | None -> ((self : #Strategie.stratacc :> Strategie.stratacc), None)
      | Some (hd1 :: hd2 :: tl) ->
	  if self#my_pos = hd1 then
	    (({< path = Some (hd2 :: tl) >} :> Strategie.stratacc), Some ((Move (get_move self#my_pos hd2)), 1))
	  else
	    new_goto ()
      | _ ->
	  new_goto ()
end 

class goto_strat pos me strat_to_apply =
object(self)
  method nextmove world =
    (new goto_strat_helper world pos me strat_to_apply)#nextmove world
end

(* class goto_strat pos me strat_to_apply = *)
(*   let my_pos = (get_robot w me).rposition in *)
(*   let path_computer = *)
(*     compute_path_from world my_pos in *)
(*   let path =  *)
(*     try *)
(*       Some (get_path path_computer pos) *)
(*     with Not_found ->  *)
(*       None in *)
(* object(self) *)
(*   val pos = pos *)
(*   val path_computer = path_computer *)
(*   val path = path *)
(*   val me = me *)
(*   val world = w *)

(*   method my_pos = (get_robot world me).rposition *)

(*   method nextmove = *)
(*     match path with *)
(*       | None -> (self, None) *)
(*       | Some [] -> start_to_apply#nextmove *)
(*       | Some (hd :: tl) -> *)
(* 	  if self#my_pos = hd then *)
(* 	    ({< path = tl >}, Some ((Move get_move my_pos pos), 1)) *)
(* 	  else *)
(* 	    (new goto_start pos me strat_to_apply)#nextmove *)
(* end *)


(*
type bdo = | GotoBase of position list
	   | Picking of packages list
	   | Delivering of packages list
	   | Droping packages list
	   | Nothing

class basic w me = 
  let closest pos l =
    let paths = Strategie.paths w pos in
    let best = ref None in
    List.iter (fun hb -> 
		 try
		   let (cost, path) as cp = Hashtbl.find paths hb in
		   (match !best with
		     None -> best := Some cp
		   | Some (oldcost, oldpath) -> 
		       if oldcost > cost then best := Some cp
		   )
		 with Not_found -> ()
	      ) l;
    !best
  in
  let bases = all_homebases w
object
  val doing = Nothing
		
  method nextmove world =
    let my = get_robot world me in
    let switch_to_gotobase () =
      match closest (get_robot w me).rposition bases with
	Some (_, revpath) -> GotoBase (List.rev revpath)
      | _ -> Gotobase []
    in
    let switch_to_pick () =
      let l = list_packages_under_pos world my.rposition in
      (* TODO : verifier que les packages sont dlivrables *)
      let lpick = Strategie.pick_packages w.capacity l in
      if lpick = [] then
	switch_to_gotobase ()
      else Picking lpick
    in 

    let switch_pushed () =
  match doing with
	Picking | GotoBase | Nothing -> switch_to_gotobase ()
      | Delivering -> switch_to_delivering ()
  let doing = if was_pushed world me || doing = Nothing then switch_pushed () else doing in
    let todo = match doing with
      GotoBase [] -> switch_to_pick ()
    | GotoBase (_::xs) -> if xs = [] then switch_to_pick () else GotoBase xs
    | Picking l -> Delivering l
    | Delivering l -> 
	
    let donothing = (Pick [], 1) in 
	({< doing = todo >},
	 match doing with
	   GotoBase p -> (match p with
			    xy::xs -> (Move (get_move my.rposition xy), 1)
			  | [] -> donothing
			 )
	 | Picking l -> 
	     (Pick (List.rev_map (fun p -> p.puid) l), 1)
	 | Delivering (l, p) ->
	     (match p with [] -> donothing
	      | x::xs -> (Move (get_move my.rposition xy), 1)
	     )
	 | Droping ->
	     List.
	     let arrivs, pasencore = List.partition (fun x -> x.destination = my.rposition) l in
	       Drop
		 
	 | Nothing -> donothing
    in
    to_action doing
*)

open Debug    
open Packages
open Printf


class basic world me = 
  let bases = all_homebases world in
object (self)
  method nextmove world =
    (* si on a des packages, on les trie et on les dlivre *)
    let my = get_robot world me in
    let mypkg = packages_on_robot world.packages me in
    let donothing = self, None in
    PacSet.iter (fun p -> debug (string_of_package p)) mypkg;
    if mypkg = PacSet.empty then (
      (* pas de pkg -> goto base *)      
      match Strategie.closest world my.rposition bases with
      | Some (_, revpath) -> 
	  (* il y a une base proche *)
	  (match List.rev revpath with
	     [] -> (* on est sur une base, on pick ce qu'on peut *)	       
	       let l = get_packages_by_location world.packages (Position my.rposition) in
	       let l = list_of_pacset l in
	       (* TODO : verifier que les packages sont dlivrables *)
	       let lpick = Strategie.pick_packages world.cst.capacity l in
	       self, Some (Pick (List.map (fun x -> x.puid) lpick), 1)
	   | xy::_ -> (* on va vers la base *)
	       self, Some (Move (get_move my.rposition xy), 1)
	  )
      | None -> (* base inaccessible *)
	  donothing
    ) else (
      (* on doit dlivrer les packages *)
      let lpacks = list_of_pacset mypkg in
      (* on cherche le plus proche *)
      (match Strategie.closest world my.rposition (List.rev_map (fun p -> p.destination) lpacks) with
       | Some (_, revpath) -> 
	   (* le plus proche est par l *)
	   (match List.rev revpath with
	      [] -> (* le(s) plus proche est(sont) en dessous *)
		let l = List.filter (fun p -> p.destination = my.rposition) lpacks in
		self, Some (Drop (List.map (fun p -> p.puid) l), 1)
	    | xy::_ -> (* on va vers le plus proche *)
		self, Some (Move (get_move my.rposition xy), 1)
	   )
       | None -> (* aucun n'est dlivrable *)
	   self, Some (Drop (List.map (fun p -> p.puid) lpacks), 1)
      )
    )
end

class ['a, 'b] meta_then (s1:'a) (s2:'b) = object (self)
  val s = s1
  method nextmove w =
    match s#nextmove w with
      _, None -> s2#nextmove w
    | s', ac -> {< s = s' >}, ac
end

class ['a, 'b] meta_sub (prio:'a) (low:'b) = object
  val sprio = prio
  val slow = low
  method nextmove w =
    match sprio#nextmove w with
      newsprio, None -> 
	let newslow, cmd = slow#nextmove w in
	{< sprio = newsprio; slow = newslow >}, cmd
    | newsprio, cmd -> {< sprio = newsprio >}, cmd
end

let meta_then a b = new meta_then a b

class drop me = object (self)

  method nextmove world =
    let my = get_robot world me in
    let mypkg = packages_on_robot world.packages me in
    let lpacks = list_of_pacset mypkg in
    let l = List.filter (fun p -> p.destination = my.rposition) lpacks in
    if l = [] then self, None
    else self, Some (Drop (List.map (fun p -> p.puid) l), 1)
    
end


class deliver me = object (self)

  method select_todeliver world =
    let my = get_robot world me in
    let mypkg = packages_on_robot world.packages me in
    if mypkg = PacSet.empty then (* pas de pkg  dlivrer *)
      None
    else
      let lpacks = list_of_pacset mypkg in
      (* on cherche le plus proche *)
      match Strategie.closest world my.rposition (List.rev_map (fun p -> p.destination) lpacks) with
      | Some (_, revpath) -> 
	  (* le plus proche est par l *)
	  (match revpath with
	     [] -> (* le(s) plus proche est(sont) en dessous *)
	       Some (get_robot world me).rposition
	   | xy::_ -> (* on va vers le plus proche *)
	       Some xy
	  )
      | None -> (* aucun n'est dlivrable *)
	  None
	
       
  method nextmove world =
    let popt = self#select_todeliver world in
    match popt with
      None -> (self :> Strategie.stratacc), None
    | Some destination -> 
	(meta_then (new goto_strat destination me (new drop me) :> Strategie.stratacc) self)#nextmove world
	  
end	  

module BaseSet = Set.Make (struct type t = Utils.position let compare = compare end)

class pick_at_home_bases_helper world me (strat : sta) last_base =
  let bases_pos = all_homebases world in
  let bases =  List.fold_right (fun x acc -> BaseSet.add x acc)
  bases_pos (BaseSet.empty) in
object(self)
  val bases = bases
  val last_base = last_base

  method update_blacklist world =
    match last_base with
      | None -> bases
      | Some pos ->
	  if Packages.get_packages_by_location world.packages
	    (Position pos) = PacSet.empty then
	      BaseSet.remove pos bases
	  else
	    bases

  method closest_bases world  bases =    
    Strategie.get_closest world (get_robot world me).rposition
      (BaseSet.fold (fun base acc -> base :: acc) bases [])

  method nextmove world =
    let bases = self#update_blacklist world in
      match self#closest_bases world bases with
	  Some closest ->
	    (new goto_strat closest me 
	    (meta_then strat
	       {< bases = bases; last_base = Some closest>}))#nextmove world
	| None -> ((self :> Strategie.stratacc), None)
end


let pick_glouton world me wmax pkg_delivrables = 
  let l = list_of_pacset pkg_delivrables in
  Strategie.pick_packages wmax l
    
    
class pick algo me = object (self)
  method nextmove world =
    let my = get_robot world me in
    let pkgs = get_packages_by_location world.packages (Position my.rposition) in
    let paths = Strategie.paths world my.rposition in
    let pkgs_deliv = PacSet.filter (fun p -> Hashtbl.mem paths p.destination) pkgs in
    let myweight = weight_of_robot world me in
    let lpick = algo world me (world.cst.capacity - myweight) pkgs_deliv in
    if lpick = [] then self, None
    else
      self, Some (Pick (List.map (fun x -> x.puid) lpick), 1)
end   

let pick_at_home_bases world me strat =
  new pick_at_home_bases_helper world me strat None

let basic_comb world me =
  pick_at_home_bases world me (meta_then (new pick pick_glouton me) (new deliver me :> Strategie.stratacc))


let iter_by_subset_weight_approx_decreasing f world me wmax pkgs = 
  let l = list_of_pacset pkgs in
  let l = List.fast_sort (fun p1 p2 -> compare p2.weight p1.weight) l in
  let rec pick picked weightsofar = function
      [] -> f picked weightsofar
    | x::xs -> 
	if x.weight + weightsofar > wmax then pick picked weightsofar xs
	else (
	  pick (x::picked) (x.weight + weightsofar) xs;
	  pick picked weightsofar xs
	)
  in
  pick [] 0 l
	  
exception Break
let pick_unpeumieux world me wmax pkg_delivrables = 
  let maxiter = 10000 in
  let best = ref None in
  (try
     let i = ref 0 in
     iter_by_subset_weight_approx_decreasing 
       (fun p wsf ->
	  (match !best with
	     None -> best := Some (p, wsf)
	   | Some (_, oldwsf) -> if oldwsf < wsf then best := Some (p, wsf)
	  );
	  incr i;
	  if !i >= maxiter then raise Break;
       )
       world me wmax pkg_delivrables;
   with Break -> ()
  );
  match !best with
    None -> []
  | Some (l, _) -> l

let basic_comb2 world me =
  pick_at_home_bases world me (meta_then (new pick pick_unpeumieux me) (new deliver me :> Strategie.stratacc))

class trygoto world me pos strat_error strat_ok =
  let my_pos = (get_robot world me).rposition in
  let path_computer = Strategie.get_path_computer world my_pos in
  let path = 
    try
      Some (my_pos :: Strategie.get_path path_computer pos)
    with Not_found -> 
      None in
object
  val path = path
  method nextmove world =
    let my_pos = (get_robot world me).rposition in
    if my_pos = pos then strat_ok#nextmove world
    else
      match path with
      | Some (p1::p2::xs) when p1 = my_pos -> 
	  {< path = Some (p2::xs) >}, Some ((Move (get_move my_pos p2)), 1)
      | _ -> strat_error#nextmove world
	  
end

class try_deliver me l strat_error = object (self)
  val l = l
  method nextmove world =
    match l with
      [] -> (self :> sta), None
    | p::xs -> 
	(* si p est encore dans la liste *)
	if PacSet.mem p (packages_on_robot world.packages me) then
	  (new trygoto world me p.destination self (meta_then (new drop me) {< l = xs >})
	     :> sta
	  )#nextmove world
	else
	  strat_error#nextmove world
end


class deliver_all delivery_order_packages me = object (self)
  method nextmove world =
    let mypkg = packages_on_robot world.packages me in
    if mypkg = PacSet.empty then (* pas de pkg  dlivrer *)
      (self :> sta), None
    else
      let l = delivery_order_packages world mypkg in
      (new try_deliver me l self)#nextmove world
end

let notbad1 world me =
  pick_at_home_bases world me (meta_then (new pick pick_unpeumieux me) 
				 (new deliver_all (fun _ -> list_of_pacset) me :> Strategie.stratacc))


class at_home_bases_helper world me (strat : sta) last_base =
  let bases_pos = all_homebases world in
  let bases = 
    List.fold_right (fun x acc -> debug ("base : " ^ (string_of_position x)); BaseMap.add x None acc)
      bases_pos (BaseMap.empty) in
object(self)
  inherit sta

  method id = "at_home_bases_helper"

  val bases = bases

  method closest_base world bases =    
    let posclosest = Strategie.get_closest world.cst (get_robot world me).rposition
		       (BaseMap.fold (fun base _ acc -> base :: acc) bases []) in
    posclosest

  method nextmove_core world =
    let my = get_robot world me in
    let pkgs_at pos =
      Packages.get_packages_by_location world.packages (Position pos)
    in
    let todostrat = BaseMap.mem my.rposition bases in
    let bases = 
      BaseMap.fold (fun basepos laststate bases ->
		      match laststate with
			None -> 
			  if my.rposition = basepos then 
			    BaseMap.add basepos (Some (pkgs_at basepos)) bases
			  else
			    bases
		      | Some lasttime ->
			  let curpkgs = pkgs_at basepos in
			  if curpkgs = PacSet.empty then (
			    debug (sprintf "Blacklist de %s car empty" (string_of_position my.rposition));
			    BaseMap.remove basepos bases
			  ) else
			    if my.rposition = basepos then (
			      if PacSet.equal lasttime curpkgs then (
				debug ("Blacklist de : " ^ string_of_position my.rposition ^ " car pas boug");
				BaseMap.remove basepos bases
			      )
			      else BaseMap.add basepos (Some curpkgs) bases
			    )
			    else bases
		   ) bases bases
    in
    if todostrat then (
      (meta_then strat {< bases = bases >})#nextmove world
    )
    else 
    match self#closest_base world bases with
      Some closest ->
	if closest = my.rposition then
	  (meta_then strat {< bases = bases >})#nextmove world
	else
	  (new goto_strat closest me 
	     {< bases = bases >})#nextmove world
    | None -> ({< bases = bases >} :> sta), None
    
end
