type robot_id = int

type robot = 
    { money : int
    ; ruid : robot_id
    ; rposition : Utils.position
    ; score : int
    }

module RobMap = Map.Make (struct type t = robot_id let compare = compare end)
module IntSet = Set.Make (struct type t = robot_id let compare = compare end)

let r_empty = RobMap.empty

let r_extract_me robots me =
  RobMap.find me robots, RobMap.remove me robots

let robot_pos r id =
  (RobMap.find id r).rposition

let r_add_robot robots r =
  RobMap.add r.ruid r robots

let r_replace_robot = r_add_robot

let r_get_robot robots ruid =
  RobMap.find ruid robots

let r_rm_robot robots r =
  RobMap.remove r robots 

let r_set_pushed pushed id =
  IntSet.add id pushed

let r_clear_pushed =
  IntSet.empty

let r_was_pushed pushed id =
  IntSet.mem id pushed

let r_fold_on_robots robots f =
  RobMap.fold f robots

let r_iter_on_robots robots f =
  RobMap.iter f robots

let string_of_rid = string_of_int

let unsafe_rid_of_int x = x
