open World
open Packages
open Debug
open Printf

class virtual stratacc = object (self)
 method virtual nextmove_core : World.world -> (stratacc * World.command option)
 method virtual id : string
  method nextmove world = 
    debug ("Strat : " ^ self#id);
    self#nextmove_core world
end

let go (p : Gestion.ct) (strat : world -> Robots.robot_id -> stratacc) =
  let world, me = p#init in
  let world = ref world
  and strat = ref (strat world me) in
    while true do
    let newstrat, coup = !strat#nextmove !world in
      world := p#update !world me (match coup with None -> Pick [], 1 | Some x -> x);
      strat := newstrat;
    done

(* algo glouton *)
let pick_packages wmax lp =
  let l = List.fast_sort (fun p1 p2 -> compare p2.weight p1.weight) lp in
  snd (List.fold_left (fun ((sumweight, ltake) as acc) p -> 
			 if sumweight + p.weight <= wmax then 
			   (sumweight + p.weight, p :: ltake)
			 else acc)
	 (0, [])
	 l
      )



let paths w ((sx, sy) as sxy) =
  try
    (match Weak.get w.paths (int_of_pos w sxy) with
	Some p -> p
      | None -> raise Not_found)
  with Not_found ->
    let hdone = Hashtbl.create 0 in
    let frontier = ref [(sxy, [])] in
      Hashtbl.add hdone (sx, sy) (0, []);
      let cost = ref 1 in
	while !frontier <> [] do
	  let newfrontier = ref [] in
	  let explore ((x, y) as xy) fromp =
	    match get_tile w x y with
		Plain | Home -> 
		  if not (Hashtbl.mem hdone xy) then (
		    let newp = xy :: fromp in
			  Hashtbl.add hdone xy (!cost, newp);
		      newfrontier := (xy, newp) :: !newfrontier
		  )
	      | _ -> ()
	  in
	    List.iter (fun ((x, y), p) -> 
			 explore ((x + 1), y) p;
			 explore ((x - 1), y) p;
			 explore (x, (y + 1)) p;
			 explore (x, (y - 1)) p;
		      ) !frontier;
	    incr cost;
	    frontier := !newfrontier
	done;
	Weak.set w.paths (int_of_pos w sxy) (Some hdone);
	hdone 
	  
let closest world pos l =
  let paths = paths world pos in
  let best = ref None in
  List.iter (fun hb -> 
	       try
		 let (cost, path) as cp = Hashtbl.find paths hb in
		 (match !best with
		    None -> best := Some cp
		  | Some (oldcost, oldpath) -> 
		      if oldcost > cost then best := Some cp
		 )
	       with Not_found -> ()
	    ) l;
  if false then (match !best with Some (c, p) ->
		   if p <> [] then (
		     let tx, ty = List.hd p in
		     debug (sprintf "de (%d,%d)  (%d,%d) cout:%d " (fst pos) (snd pos) tx ty c);
		     debug (List.fold_left (fun acc (x, y) -> acc ^ (sprintf "(%d, %d)" x y)) "" (List.rev p));
		   )
		 | _ -> ()
		);
  !best

let get_path_computer = paths

let is_reachable path_computer pos =
  Hashtbl.mem path_computer pos

let get_path path_computer pos =
  List.rev (snd (Hashtbl.find path_computer pos))

let get_dist path_computer pos =
  fst (Hashtbl.find path_computer pos)

let get_closest world pos l =
  match closest world pos l with
      None -> None
    | Some (_, (p :: _)) -> Some p
    | _ -> Some pos
